
#ifndef TSA_H_
#define TSA_H_

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

class TSA {
public:
    unsigned posbits;
    unsigned lcpbits;
    unsigned *pos;
    unsigned *lcp;
    unsigned *B;
    bool jumpinnext;

    void printbits(unsigned x);
    void CreatePosArray(unsigned bits, unsigned n);
    void CreateLCPArray(unsigned bits, unsigned n, bool jump);
    void CreateBooleanArray(unsigned n);
	void DeletePosArray();
	void DeleteLCPArray();
	void DeleteBooleanArray(unsigned n);
	void SetLCP(unsigned index,unsigned x);
	void SetLCPl(unsigned index);
	void SetLCPr(unsigned index);
	void SetJump(unsigned index, unsigned x);
	void SetDepth(unsigned index, unsigned x);
	void SetPos(unsigned index, unsigned x);
	void SetB(unsigned index, unsigned x);
	unsigned GetLCP(unsigned index);
	unsigned GetLCPl(unsigned index);
	unsigned GetLCPr(unsigned index);
	unsigned GetJump(unsigned index);
	unsigned GetDepth(unsigned index);
	unsigned GetPos(unsigned index);
	bool GetB(unsigned index);

private:
    void SetField(unsigned *A, unsigned len, unsigned index, unsigned x);
    unsigned GetField(unsigned *A, unsigned len, unsigned index);

};

#endif /* TSA_H_ */
